=== debian/changelog ===
scap-security-guide (0.1.31-5) unstable; urgency=medium

  * Updated shared guide management (Closes: #871353).
  * Update standard version to 4.0.0
  * Update compat level to 10

 -- Philippe Thierry <phil@reseau-libre.net>  Fri, 11 Aug 2017 11:18:08 +0200

scap-security-guide (0.1.31-4) unstable; urgency=medium

  * Switch maintainer to pkg-security team.
  * Corrected spell check (lintian W).
  * Add remediations for OS XCCDF benchmarks.
    support for puppet, bash, anaconda and ansible
  * updated share directory to /usr/share/scap-security-guide.

 -- Philippe Thierry <phil@reseau-libre.net>  Thu, 20 Apr 2017 09:22:51 +0200

scap-security-guide (0.1.31-3) unstable; urgency=medium

  * Updated Multiarch hinter for all packages
  * Updated control file to take into acount G. Costamagna remarks to ITP
  * Updated README.Debian to describe security server use case
  * Upload sponsored by Petter Reinholdtsen.

 -- Philippe Thierry <phil@reseau-libre.net>  Mon, 10 Apr 2017 15:06:06 +0200

scap-security-guide (0.1.31-2) unstable; urgency=medium

  * Updated Multiarch hinter for ssg-base
  * Upload sponsored by Petter Reinholdtsen.

 -- Philippe Thierry <phil@reseau-libre.net>  Fri, 24 Mar 2017 10:34:04 +0100

scap-security-guide (0.1.31-1) unstable; urgency=medium

  * Initial Release (Closes: #856425).
  * Add support for upstream changelog
    integrated manually before build, from github ReleaseNote
    support for getting upstream version from debian changelog
  * Add dep5 conform quilt patches headers
  * Updated binary packages name to simplify the structure
  * Bin packages are family-based, debian-centric
  * Add SuSE 11 benchmarks and guides
  * Add proper copyright dep5 copyright file
  * Updated run-time dependencies
  * Set libopenscap8 as recommends, for security policy server cases
  * Cleaned all residual lintian warnings/infos
  * Updated man page to be compliant to lexgrog
  * Updated spelling mistakes and various syntax errors
  * Updated html files path (guide subdir added)
  * Declare guides as docs (for lintian conformity), add doc-base
  * Add RHEL guides and benchmarks
  * Add XCCDF benchmarks and guides for JRE and Webmin
  * Updated control file to use correct Standard-version
  * Add watch file for uscan
  * Upload sponsored by Petter Reinholdtsen.

 -- Philippe Thierry <phil@reseau-libre.net>  Wed, 01 Mar 2017 18:25:10 +0100
