=== debian/control ===
Source: scap-security-guide
Section: admin
Priority: optional
Maintainer: Debian Security Tools Packaging Team <pkg-security-team@lists.alioth.debian.org>
Uploaders: Philippe Thierry <phil@reseau-libre.net>
Build-Depends:
 debhelper (>=10),
 python (>> 2.7),
 python-requests,
 xsltproc,
 expat,
 python-lxml,
 libxml2-utils,
 libopenscap8
Standards-Version: 4.0.0
XS-Python-Version: >= 2.7
Homepage: https://www.open-scap.org/security-policies/scap-security-guide
Vcs-Git: https://anonscm.debian.org/git/pkg-security/scap-security-guide.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-security/scap-security-guide.git/

Package: ssg-base
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Recommends: libopenscap8
Suggests: ansible, puppet
Description: SCAP Security guide base content and documentation
 This package contains the basic content and manual pages explaining how
 the SCAP-security-guide works. It deploys man page and all various
 information about current SSG release.
 .
 SCAP (Security Content Automation Protocol) is a set of standards used in
 order to automatically manage vulnerabilities and policy compliance
 evaluation on a complete deployed infrastructure. SSG provides various
 official policies such as PCI-DSS, NIST SP-800-53 or ANSSI best practices
 as official policies.

Package: ssg-debian
Architecture: all
Depends: ${misc:Depends}, ssg-base
Multi-Arch: foreign
Description: SCAP Guides and benchmarks targeting Debian 8
 This package contains all the SCAP guides, benchmarks and remediation
 files for Debian Jessie. Remediation files are Shell-based, Ansible-based
 and Puppet-based depending on the target infrastructure deployment policy.
 .
 SCAP (Security Content Automation Protocol) is a set of standards used in
 order to automatically manage vulnerabilities and policy compliance
 evaluation on a complete deployed infrastructure. SSG provides various
 official policies such as PCI-DSS, NIST SP-800-53 or ANSSI best practices
 as official policies.

Package: ssg-debderived
Architecture: all
Depends: ${misc:Depends}, ssg-base
Multi-Arch: foreign
Description: SCAP Guides and benchmarks targeting Debian-based OS
 This package contains all the SCAP guides for deb-based distributions
 such as Ubuntu Trusty or Xenial.
 This package contains all the SCAP guides, benchmarks and remediation
 files. Remediation files are Shell-based, Ansible-based  and
 Puppet-based depending on the target infrastructure deployment policy.
 .
 SCAP (Security Content Automation Protocol) is a set of standards used in
 order to automatically manage vulnerabilities and policy compliance
 evaluation on a complete deployed infrastructure. SSG provides various
 official policies such as PCI-DSS, NIST SP-800-53 or ANSSI best practices
 as official policies.

Package: ssg-applications
Architecture: all
Depends: ${misc:Depends}, ssg-base
Multi-Arch: foreign
Description: SCAP Guides and benchmarks targeting userspace applications
 This package contains all the SCAP guides, benchmarks and remediation
 files for userspace applications. Remediation files are Shell-based,
 Ansible-based and Puppet-based depending on the target infrastructure
 deployment policy.
 .
 SCAP (Security Content Automation Protocol) is a set of standards used in
 order to automatically manage vulnerabilities and policy compliance
 evaluation on a complete deployed infrastructure. SSG provides various
 official policies such as PCI-DSS, NIST SP-800-53 or ANSSI best practices
 as official policies.

Package: ssg-nondebian
Architecture: all
Depends: ${misc:Depends}, ssg-base
Multi-Arch: foreign
Description: SCAP Guides and benchmarks targeting other GNU/Linux OS
 This package contains all the SCAP guides, benchmarks and remediation
 files for nondebian operating system targets such as Red-Hat RHEL or SuSE.
 Remediation files are Shell-based, Ansible-based and Puppet-based depending
 on the target infrastructure deployment policy.
 .
 SCAP (Security Content Automation Protocol) is a set of standards used in
 order to automatically manage vulnerabilities and policy compliance
 evaluation on a complete deployed infrastructure. SSG provides various
 official policies such as PCI-DSS, NIST SP-800-53 or ANSSI best practices
 as official policies.
